# Class VulkanDescriptorSetAllocateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanDescriptorSetAllocateInfo

All Implemented Interfaces:
  `VulkanDescriptorSetAllocateInfoType`

public final class VulkanDescriptorSetAllocateInfo extends Object implements VulkanDescriptorSetAllocateInfoType

See Also:
  - "VkDescriptorSetAllocateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanDescriptorSetAllocateInfo.Builder`
  Builds instances of type `VulkanDescriptorSetAllocateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanDescriptorSetAllocateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanDescriptorSetAllocateInfo`.
  `static VulkanDescriptorSetAllocateInfo`
  `copyOf(VulkanDescriptorSetAllocateInfoType instance)`
  Creates an immutable copy of a `VulkanDescriptorSetAllocateInfoType` value.
  `List<Long>`
  `descriptorCounts()`
  If `VulkanDescriptorBindingFlag.VK_DESCRIPTOR_BINDING_VARIABLE_DESCRIPTOR_COUNT` is used, each element in this list specifies the descriptor count for the corresponding layout in `setLayouts()`.
  `VulkanDescriptorPoolType`
  `descriptorPool()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanDescriptorSetAllocateInfo` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `descriptorPool`, `setLayouts`, `descriptorCounts`.
  `List<VulkanDescriptorSetLayoutType>`
  `setLayouts()`
  `String`
  `toString()`
  Prints the immutable value `VulkanDescriptorSetAllocateInfo` with attribute values.
  `final VulkanDescriptorSetAllocateInfo`
  `withDescriptorCounts(long... elements)`
  Copy the current immutable object with elements that replace the content of `descriptorCounts`.
  `final VulkanDescriptorSetAllocateInfo`
  `withDescriptorCounts(Iterable<Long> elements)`
  Copy the current immutable object with elements that replace the content of `descriptorCounts`.
  `final VulkanDescriptorSetAllocateInfo`
  `withDescriptorPool(VulkanDescriptorPoolType value)`
  Copy the current immutable object by setting a value for the `descriptorPool` attribute.
  `final VulkanDescriptorSetAllocateInfo`
  `withSetLayouts(VulkanDescriptorSetLayoutType... elements)`
  Copy the current immutable object with elements that replace the content of `setLayouts`.
  `final VulkanDescriptorSetAllocateInfo`
  `withSetLayouts(Iterable<? extends VulkanDescriptorSetLayoutType> elements)`
  Copy the current immutable object with elements that replace the content of `setLayouts`.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface VulkanDescriptorSetAllocateInfoType

  `checkPreconditions`

- ## Method Details

  - ### descriptorPool

    public VulkanDescriptorPoolType descriptorPool()
    Specified by:
      `descriptorPool` in interface `VulkanDescriptorSetAllocateInfoType`
    Returns:
      The descriptor pool from which descriptor sets will be allocated

  - ### setLayouts

    public List<VulkanDescriptorSetLayoutType> setLayouts()
    Specified by:
      `setLayouts` in interface `VulkanDescriptorSetAllocateInfoType`
    Returns:
      An array of descriptor set layouts, with each member specifying how the corresponding descriptor set is allocated.

  - ### descriptorCounts

    public List<Long> descriptorCounts()
    If `VulkanDescriptorBindingFlag.VK_DESCRIPTOR_BINDING_VARIABLE_DESCRIPTOR_COUNT` is used, each element in this list specifies the descriptor count for the corresponding layout in `setLayouts()`.
    Specified by:
      `descriptorCounts` in interface `VulkanDescriptorSetAllocateInfoType`
    Returns:
      The list of descriptor counts
    See Also:
      - "VkDescriptorSetVariableDescriptorCountAllocateInfo"

  - ### withDescriptorPool

    public final VulkanDescriptorSetAllocateInfo withDescriptorPool(VulkanDescriptorPoolType value)
    Copy the current immutable object by setting a value for the `descriptorPool` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for descriptorPool
    Returns:
      A modified copy or the `this` object

  - ### withSetLayouts

    public final VulkanDescriptorSetAllocateInfo withSetLayouts(VulkanDescriptorSetLayoutType... elements)
    Copy the current immutable object with elements that replace the content of `setLayouts`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withSetLayouts

    public final VulkanDescriptorSetAllocateInfo withSetLayouts(Iterable<? extends VulkanDescriptorSetLayoutType> elements)
    Copy the current immutable object with elements that replace the content of `setLayouts`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of setLayouts elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withDescriptorCounts

    public final VulkanDescriptorSetAllocateInfo withDescriptorCounts(long... elements)
    Copy the current immutable object with elements that replace the content of `descriptorCounts`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withDescriptorCounts

    public final VulkanDescriptorSetAllocateInfo withDescriptorCounts(Iterable<Long> elements)
    Copy the current immutable object with elements that replace the content of `descriptorCounts`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of descriptorCounts elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanDescriptorSetAllocateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `descriptorPool`, `setLayouts`, `descriptorCounts`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanDescriptorSetAllocateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanDescriptorSetAllocateInfo copyOf(VulkanDescriptorSetAllocateInfoType instance)
    Creates an immutable copy of a `VulkanDescriptorSetAllocateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanDescriptorSetAllocateInfo instance

  - ### builder

    public static VulkanDescriptorSetAllocateInfo.Builder builder()
    Creates a builder for `VulkanDescriptorSetAllocateInfo`.

        VulkanDescriptorSetAllocateInfo.builder()
           .setDescriptorPool(com.io7m.jcoronado.api.VulkanDescriptorPoolType) // required descriptorPool
           .addSetLayouts|addAllSetLayouts(com.io7m.jcoronado.api.VulkanDescriptorSetLayoutType) // setLayouts elements
           .addDescriptorCounts|addAllDescriptorCounts(long) // descriptorCounts elements
           .build();

    Returns:
      A new VulkanDescriptorSetAllocateInfo builder